package pathfinder;

import java.util.ArrayList;

public class Node implements Comparable<Node> {
    
    public final int x, y;
    private final static int neighbourCount = 8;
    Node parent;
    
    float f, g, h;
    boolean inOpenList, inClosedList;
    
    Node(int x, int y){
        this.x = x;
        this.y = y;
        reset();
    }

    void setValues(float h, float g){
        this.h = h;
        this.g = g;
        this.f = h + g;
    }

    void reset(){
        setValues(AStar.UNKNOWN, AStar.UNKNOWN);
        parent = null;
        inOpenList = inClosedList = false;
        f = g = h = AStar.UNKNOWN;
    }
    
    public int compareTo(Node other){
        return (int)(other.f - this.f); //f-values are generally large enough that this shouldn't be a problem
    }
    
    public boolean isInClosedList(){
        return inClosedList;
    }
    
    public boolean isInOpenList(){
        return inOpenList;
    }
}
