package pathfinder;

import java.util.List;

public abstract class PathFinder{
    
    public final int width, height;
    
    public final static int RUNNING = 0;
    public final static int ERROR = -1;
    public final static int COMPLETED = 1;
    
    public PathFinder(int width, int height){
        this.width = width;
        this.height = height;
    }
    
    public abstract boolean setup(int srcX, int srcY, int dstX, int dstY, PathClient client);
    public abstract int findPath(int iterations);
    public abstract List<Node> getPath();
    
}
