/*
 * Main.java
 *
 * Created on July 9, 2007, 6:32 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package pathfinder.test;
import java.util.Random;

import pathfinder.*;

/**
 *
 * @author ask
 */
public class Main {
    
    public static void main(String[] args){
        if(args.length > 0){
            String str = args[0];
            if("graphical".equals(str)){
                graphicalTest();
            } else if("prof".equals(str)){
                profilingTest();
            } else {
                System.out.println("Bad arguments");
                System.exit(0);
            }
        } else {
            graphicalTest();
            //profilingTest();
        }
    }
    
    public static void profilingTest(){
        int width = 64;
        int height = 64;
        CollisionDetector cd = new MaskCollisionDetector(width, height, 0L, 16);
        AStar aStar = new AStar(width, height);
        int count = 1<<16;
        long time = System.currentTimeMillis();
        System.out.println("Running pathfinder "+count+ " times");
        Random rand = new Random(1L);
        
        //GUI gui = new GUI(aStar,cd ,width, height);
        
        int i = 0;
        while(i < count){
            int x1 = 1 + rand.nextInt(width-2);
            int y1 = 1 + rand.nextInt(height-2);
            int x2 = 1 + rand.nextInt(width-2);
            int y2 = 1 + rand.nextInt(height-2);
            
            boolean ready = aStar.setup(x1,y1,x2,y2, cd);
            
            if(!ready){
                continue;
            }
            i++;
            //System.out.println("SET SRC #"+ i+" " +aStar.getSrc().x + ","+aStar.getSrc().y);
            int status = aStar.RUNNING;
            int maxIterations = 1024;
            int iterCount = 0;
            //GUI gui = new GUI(aStar, cd, width, height);
            while((status==aStar.RUNNING) && (iterCount=aStar.getIterationCount()) < maxIterations){
                status = aStar.iterate();
            }
            //System.out.println("Status "+status + ", iterations "+iterCount);            
            /*if(iterCount == maxIterations){
                try{
                    System.out.println("reading");
                    System.in.read();
                    gui.repaint();
                } catch(Exception ex){
                    System.exit(0);
                }
            }*/
        }
        time = System.currentTimeMillis() - time;
        System.out.println("Time (s): "+time/1000);
        System.out.println("T/run (µs): "+1000*time/count);
    }
    
    /**
     * @param args the command line arguments
     */
    public static void graphicalTest() {
        //CollisionDetector cd = new StandardCollisionDetector();
        //CollisionDetector cd = new LandscapeCollisionDetector();
        CollisionDetector cd = new MaskCollisionDetector();
        int width = cd.getWidth(), height = cd.getHeight();
        AStar aStar = new AStar(width, height);
        GUI gui = new GUI(aStar, cd, width, height);
        aStar.setup(5,11,7,5, cd);
        gui.repaint();
        //AStar pf = new AStar(cd, 16 ,16);
        //pf.setupPath(3,3, 7,7);
        //while(!pf.iterate());
        
    }
    
}
